
% fuse classifiers and get ensemble predictors
% then predict independent biomarker dataset(IBD) and independent normal dataset (IDN)

% str can be 'AsemiB',or 'A2semiB', or 'A3semiB', or 'AsemiBC',or 'A2semiBC', 
% 'A3semiBC', or 'EAsemiB', or 'EAsemiBC'.
str = 'AsemiB';

addPath();
dbs = {'db1','db2','db3','db4','db5','db6','db7','db8','db9','db10'};
classifierPath = './data/results_Dcriterion';
classifyPath = ['./data/results_prediction/' str];
if ~exist(classifyPath,'dir')
    mkdir(classifyPath);
end

% 1. load all classifiers and calculate the ensembled parameters in D-criterion.
% get models
classifier = [];
for dbnum = 1:length(dbs)
    switch str
        case {'EAsemiB','EAsemiBC'}
            Ensemstr = {str(2:end),['A2' str(3:end)],['A3' str(3:end)]}; % {'AsemiB','A2semiB','A3semiB'} or {'AsemiBC','A2semiBC','A3semiBC'}
            eval(['model_' str  '= [];']);
            for i = 1:length(Ensemstr)
                load([classifierPath '/' dbs{dbnum} '/' Ensemstr{i} '/done.mat']);
                load([classifierPath '/' dbs{dbnum} '/' Ensemstr{i} '/classifier_' Ensemstr{i} '_' num2str(size(done,2)) '.mat'],['model_' Ensemstr{i}]);
                eval(['EnsemModel = model_' Ensemstr{i} ';']);
                if length(EnsemModel) == 1
                    eval(['model_' str '{1} = [model_' str ' EnsemModel];']);
                else
                    eval(['model_' str ' = [model_' str ' EnsemModel];']);
                end                    
            end
        otherwise
            load([classifierPath '/' dbs{dbnum} '/' str '/done.mat']);
            load([classifierPath '/' dbs{dbnum} '/' str '/classifier_' str '_' num2str(size(done,2)) '.mat'],['model_' str]);
    end
    eval(['model = model_' str ';']); % get model
            
    if length(model) == 1
        classifier = [classifier model];
    else
        for i = 1:length(model)
            classifier = [classifier model{i}];
        end   
    end
end

% get trainData and determine sita and cons
classifierNum = length(classifier);
n = classifierNum/length(dbs);
switch str 
    case 'AsemiB'
        if ~exist([classifyPath '/parameters.mat'],'file')
            load('./data/datasets/data.mat','ADN','ADN_target','BDN','BDN_target');
            inter = 1:size(BDN{1},1);
            for dbnum = 1:length(dbs)
                load([classifierPath '/' dbs{dbnum} '/' str '/done.mat']);
                load([classifierPath '/' dbs{dbnum} '/' str '/markNum.mat']);
                trainData_db = [ADN{dbnum}; BDN{dbnum}(markNum{size(done,2)},:)];
                target_db = [ADN_target BDN_target(:,markNum{size(done,2)})];
                model = classifier(dbnum);

                for i=1:size(trainData_db,2)
                    trainData_db(:,i) = trainData_db(:,i) - model.MI(i);
                    trainData_db(:,i) = trainData_db(:,i) / model.MA(i);
                end
                trainData_db(trainData_db>1)=1;
                trainData_db(trainData_db<0)=0;
                trainData_db = double(trainData_db*2-1);
                trainOutputs{dbnum} = OutputsByFold(trainData_db(:,model.idx_sda),target_db,6,5); % num_class=6,foldNum=5
                inter = intersect(inter,markNum{size(done,2)});
                markNum_all{dbnum} = markNum{size(done,2)};
            end
            asize = size(ADN_target,2);
            trainOutputs_all = zeros(6,asize+length(inter));
            for dbnum = 1:length(dbs)
                [~, ~, ib] = intersect(inter, markNum_all{dbnum});
                trainOutputs_all = trainOutputs_all + trainOutputs{dbnum}(:,[1:asize ib+asize]);
            end
            trainOutputs_all = trainOutputs_all/length(dbs); 
            [cons,sita] =  fitSita(trainOutputs_all,[ADN_target BDN_target(:,inter)]); 
            parameters = [cons sita];
            save([classifyPath '/parameters.mat'],'parameters');
            save([classifyPath '/records.mat'],'trainOutputs','markNum_all','inter');
        else
            load([classifyPath '/parameters.mat']);
        end
    case {'A2semiB','A3semiB'}
        if ~exist([classifyPath '/parameters.mat'],'file')
            load('./data/datasets/data.mat','ADN','ADN_target','BDN','BDN_target');
            intera = 1:size(ADN{1},1);
            interb = 1:size(BDN{1},1);
            for dbnum = 1:length(dbs)
                load([classifierPath '/' dbs{dbnum} '/' str '/done.mat']);
                load([classifierPath '/' dbs{dbnum} '/' str '/markNum.mat']);
                load([classifierPath '/' dbs{dbnum} '/' str '/labeledNum.mat']);
                for i = 1:n
                    trainData_db = [ADN{dbnum}(labeledNum{i},:); BDN{dbnum}(markNum{size(done,2)}{i},:)];
                    target_db = [ADN_target(:,labeledNum{i}) BDN_target(:,markNum{size(done,2)}{i})];
                    model = classifier((dbnum-1)*n+i);

                    for j=1:size(trainData_db,2)
                        trainData_db(:,j) = trainData_db(:,j) - model.MI(j);
                        trainData_db(:,j) = trainData_db(:,j) / model.MA(j);
                    end
                    trainData_db(trainData_db>1)=1;
                    trainData_db(trainData_db<0)=0;
                    trainData_db = double(trainData_db*2-1);
                    trainOutputs{(dbnum-1)*n+i} = OutputsByFold(trainData_db(:,model.idx_sda),target_db,6,5); % num_class=6,foldNum=5
                    intera = intersect(intera,labeledNum{i});
                    markNuma_all{dbnum}{i} = labeledNum{i};
                    interb = intersect(interb,markNum{size(done,2)}{i});
                    markNumb_all{dbnum}{i} = markNum{size(done,2)}{i};
                end
            end
            trainOutputs_all = zeros(6,length(intera) + length(interb));
            for dbnum = 1:length(dbs)
                for i = 1:n
                    asize = length(markNuma_all{dbnum}{i});
                    [~, ~, ia] = intersect(intera, markNuma_all{dbnum}{i});
                    [~, ~, ib] = intersect(interb, markNumb_all{dbnum}{i});
                    trainOutputs_all = trainOutputs_all + trainOutputs{(dbnum-1)*n+i}(:,[ia ib+asize]);
                end
            end
            trainOutputs_all = trainOutputs_all/(n*length(dbs));
            [cons,sita] =  fitSita(trainOutputs_all,[ADN_target(:,intera) BDN_target(:,interb)]); 
            parameters = [cons sita];
            save([classifyPath '/parameters.mat'],'parameters');
            save([classifyPath '/records.mat'],'trainOutputs','markNuma_all','intera','markNumb_all','interb');
        else
            load([classifyPath '/parameters.mat']);
        end
    case 'AsemiBC'
        if ~exist([classifyPath '/parameters.mat'],'file')
            load('./data/datasets/data.mat','ADN','ADN_target','BDN','BDN_target','CDC','CDC_normalTarget');
            interb = 1:size(BDN{1},1);
            interc = 1:size(CDC{1},1);
            for dbnum = 1:length(dbs)
                load([classifierPath '/' dbs{dbnum} '/AsemiB/done.mat']);
                load([classifierPath '/' dbs{dbnum} '/AsemiB/markNum.mat']);
                trainData_db = [ADN{dbnum}; BDN{dbnum}(markNum{size(done,2)},:)];
                target_db = [ADN_target BDN_target(:,markNum{size(done,2)})];
                interb = intersect(interb,markNum{size(done,2)});
                markNumb_all{dbnum} = markNum{size(done,2)};
                
                load([classifierPath '/' dbs{dbnum} '/' str '/done.mat']);
                load([classifierPath '/' dbs{dbnum} '/' str '/markNum.mat']);
                trainData_db = [trainData_db; CDC{dbnum}(markNum{size(done,2)},:)];
                target_db = [target_db CDC_normalTarget(:,markNum{size(done,2)})];
                interc = intersect(interc,markNum{size(done,2)});
                markNumc_all{dbnum} = markNum{size(done,2)};
                model = classifier(dbnum);
                
                for i=1:size(trainData_db,2)
                    trainData_db(:,i) = trainData_db(:,i) - model.MI(i);
                    trainData_db(:,i) = trainData_db(:,i) / model.MA(i);
                end
                trainData_db(trainData_db>1)=1;
                trainData_db(trainData_db<0)=0;
                trainData_db = double(trainData_db*2-1);
                trainOutputs{dbnum} = OutputsByFold(trainData_db(:,model.idx_sda),target_db,6,5); % num_class=6,foldNum=5
            end
            asize = size(ADN_target,2);
            trainOutputs_all = zeros(6,asize+length(interb)+length(interc));
            for dbnum = 1:length(dbs)
                bsize = length(markNumb_all{dbnum});
                [~, ~, ib] = intersect(interb, markNumb_all{dbnum});
                [~, ~, ic] = intersect(interc, markNumc_all{dbnum});
                trainOutputs_all = trainOutputs_all + trainOutputs{dbnum}(:,[1:asize ib+asize ic+asize+bsize]);
            end
            trainOutputs_all = trainOutputs_all/length(dbs); 
            [cons,sita] =  fitSita(trainOutputs_all,[ADN_target BDN_target(:,interb) CDC_normalTarget(:,interc)]); 
            parameters = [cons sita];
            save([classifyPath '/parameters.mat'],'parameters');
            save([classifyPath '/records.mat'],'trainOutputs','markNumb_all','interb','markNumc_all','interc');
        else
            load([classifyPath '/parameters.mat']);
        end
    case {'A2semiBC','A3semiBC'}
        if ~exist([classifyPath '/parameters.mat'],'file')
            load('./data/datasets/data.mat','ADN','ADN_target','BDN','BDN_target','CDC','CDC_normalTarget');
            intera = 1:size(ADN{1},1);
            interb = 1:size(BDN{1},1);
            interc = 1:size(CDC{1},1);
            for dbnum = 1:length(dbs)
                for i = 1:n
                    load([classifierPath '/' dbs{dbnum} '/' str(1:end-1) '/done.mat']);
                    load([classifierPath '/' dbs{dbnum} '/' str(1:end-1) '/markNum.mat']);
                    load([classifierPath '/' dbs{dbnum} '/' str(1:end-1) '/labeledNum.mat']);
                    trainData_db = [ADN{dbnum}(labeledNum{i},:); BDN{dbnum}(markNum{size(done,2)}{i},:)];
                    target_db = [ADN_target(:,labeledNum{i}) BDN_target(:,markNum{size(done,2)}{i})];
                    intera = intersect(intera,labeledNum{i});
                    markNuma_all{dbnum} = labeledNum;
                    interb = intersect(interb,markNum{size(done,2)}{i});
                    markNumb_all{dbnum} = markNum{size(done,2)};

                    load([classifierPath '/' dbs{dbnum} '/' str '/done.mat']);
                    load([classifierPath '/' dbs{dbnum} '/' str '/markNum.mat']);
                    trainData_db = [trainData_db; CDC{dbnum}(markNum{size(done,2)}{i},:)];
                    target_db = [target_db CDC_normalTarget(:,markNum{size(done,2)}{i})];
                    interc = intersect(interc,markNum{size(done,2)}{i});
                    markNumc_all{dbnum} = markNum{size(done,2)};
                    model = classifier((dbnum-1)*n+i);

                    for j=1:size(trainData_db,2)
                        trainData_db(:,j) = trainData_db(:,j) - model.MI(j);
                        trainData_db(:,j) = trainData_db(:,j) / model.MA(j);
                    end
                    trainData_db(trainData_db>1)=1;
                    trainData_db(trainData_db<0)=0;
                    trainData_db = double(trainData_db*2-1);
                    trainOutputs{(dbnum-1)*n+i} = OutputsByFold(trainData_db(:,model.idx_sda),target_db,6,5); % num_class=6,foldNum=5
                end
            end
            trainOutputs_all = zeros(6,length(intera)+length(interb)+length(interc));
            for dbnum = 1:length(dbs)
                for i = 1:n
                    asize = length(markNuma_all{dbnum}{i});
                    bsize = length(markNumb_all{dbnum}{i});
                    [~, ~, ia] = intersect(intera, markNuma_all{dbnum}{i});
                    [~, ~, ib] = intersect(interb, markNumb_all{dbnum}{i});
                    [~, ~, ic] = intersect(interc, markNumc_all{dbnum}{i});
                    trainOutputs_all = trainOutputs_all + trainOutputs{(dbnum-1)*n+i}(:,[ia ib+asize ic+asize+bsize]);
                end
            end
            trainOutputs_all = trainOutputs_all/(n*length(dbs));
            [cons,sita] =  fitSita(trainOutputs_all,[ADN_target(:,intera) BDN_target(:,interb) CDC_normalTarget(:,interc)]); 
            parameters = [cons sita];
            save([classifyPath '/parameters.mat'],'parameters');
            save([classifyPath '/records.mat'],'trainOutputs','markNuma_all','intera','markNumb_all','interb','markNumc_all','interc');
        else
            load([classifyPath '/parameters.mat']);
        end
    case 'EAsemiB'
        if ~exist([classifyPath '/parameters.mat'],'file')
            load('./data/datasets/data.mat','ADN','ADN_target','BDN','BDN_target');
            load('./data/results_prediction/AsemiB/records.mat','inter');
            ensemib{1} = inter;
            for i = 2:length(Ensemstr)
                load(['./data/results_prediction/' Ensemstr{i} '/records.mat'],'intera','interb');
                ensemia{i-1} = intera;
                ensemib{i} = interb;
            end
            intera = intersect(ensemia{1},ensemia{2});
            interb = intersect(ensemib{1},intersect(ensemib{2},ensemib{3}));
            trainOutputs_all = zeros(6,length(intera)+length(interb));
            
            for dbnum = 1:length(dbs)
                load('./data/results_prediction/AsemiB/records.mat','markNum_all','trainOutputs');
                [~, ~, ib] = intersect(interb, markNum_all{dbnum});
                asize = size(ADN_target,2);
                trainOutputs_all = trainOutputs_all + trainOutputs{dbnum}(:,[intera ib+asize]);
                
                load('./data/results_prediction/A2semiB/records.mat','markNuma_all','markNumb_all','trainOutputs');
                for i = 1:2
                    [~, ~, ia] = intersect(intera, markNuma_all{dbnum}{i});
                    [~, ~, ib] = intersect(interb, markNumb_all{dbnum}{i});
                    asize = length(markNuma_all{dbnum}{i});
                    trainOutputs_all = trainOutputs_all + trainOutputs{(dbnum-1)*2+i}(:,[ia ib+asize]);
                end
                
                load('./data/results_prediction/A3semiB/records.mat','markNuma_all','markNumb_all','trainOutputs');
                for i = 1:3
                    [~, ~, ia] = intersect(intera, markNuma_all{dbnum}{i});
                    [~, ~, ib] = intersect(interb, markNumb_all{dbnum}{i});
                    asize = length(markNuma_all{dbnum}{i});
                    trainOutputs_all = trainOutputs_all + trainOutputs{(dbnum-1)*3+i}(:,[ia ib+asize]);
                end
            end
            trainOutputs_all = trainOutputs_all/(n*length(dbs)); 
            [cons,sita] =  fitSita(trainOutputs_all,[ADN_target(:,intera) BDN_target(:,interb)]); 
            parameters = [cons sita];
            save([classifyPath '/parameters.mat'],'parameters');            
        else
            load([classifyPath '/parameters.mat']);
        end
    case 'EAsemiBC'
        if ~exist([classifyPath '/parameters.mat'],'file')
            load('./data/datasets/data.mat','ADN','ADN_target','BDN','BDN_target','CDC','CDC_normalTarget');
            load('./data/results_prediction/AsemiBC/records.mat','interb','interc');
            ensemib{1} = interb;  ensemic{1} = interc;
            for i = 2:length(Ensemstr)
                load(['./data/results_prediction/' Ensemstr{i} '/records.mat'],'intera','interb','interc');
                ensemia{i-1} = intera;
                ensemib{i} = interb;
                ensemic{i} = interc;
            end
            intera = intersect(ensemia{1},ensemia{2});
            interb = intersect(ensemib{1},intersect(ensemib{2},ensemib{3}));
            interc = intersect(ensemic{1},intersect(ensemic{2},ensemic{3}));
            trainOutputs_all = zeros(6,length(intera)+length(interb)+length(interc));            
            for dbnum = 1:length(dbs)
                load('./data/results_prediction/AsemiBC/records.mat','markNumb_all','markNumc_all','trainOutputs');
                [~, ~, ib] = intersect(interb, markNumb_all{dbnum});
                [~, ~, ic] = intersect(interc, markNumc_all{dbnum});
                asize = size(ADN_target,2);
                bsize = length(markNumb_all{dbnum});
                trainOutputs_all = trainOutputs_all + trainOutputs{dbnum}(:,[intera ib+asize ic+asize+bsize]);
                
                load('./data/results_prediction/A2semiBC/records.mat','markNuma_all','markNumb_all','markNumc_all','trainOutputs');
                for i = 1:2
                    [~, ~, ia] = intersect(intera, markNuma_all{dbnum}{i});
                    [~, ~, ib] = intersect(interb, markNumb_all{dbnum}{i});
                    [~, ~, ic] = intersect(interc, markNumc_all{dbnum}{i});
                    asize = length(markNuma_all{dbnum}{i});
                    bsize = length(markNumb_all{dbnum}{i});
                    trainOutputs_all = trainOutputs_all + trainOutputs{(dbnum-1)*2+i}(:,[ia ib+asize ic+asize+bsize]);
                end
                
                load('./data/results_prediction/A3semiBC/records.mat','markNuma_all','markNumb_all','markNumc_all','trainOutputs');
                for i = 1:3
                    [~, ~, ia] = intersect(intera, markNuma_all{dbnum}{i});
                    [~, ~, ib] = intersect(interb, markNumb_all{dbnum}{i});
                    [~, ~, ic] = intersect(interc, markNumc_all{dbnum}{i});
                    asize = length(markNuma_all{dbnum}{i});
                    bsize = length(markNumb_all{dbnum}{i});
                    trainOutputs_all = trainOutputs_all + trainOutputs{(dbnum-1)*3+i}(:,[ia ib+asize ic+asize+bsize]);
                end
            end
            trainOutputs_all = trainOutputs_all/(n*length(dbs)); 
            [cons,sita] =  fitSita(trainOutputs_all,[ADN_target(:,intera) BDN_target(:,interb) CDC_normalTarget(:,interc)]); 
            parameters = [cons sita];
            save([classifyPath '/parameters.mat'],'parameters');            
        else
            load([classifyPath '/parameters.mat']);
        end
end

% 2. load independent biomarker dataset and test them  
if ~exist([classifyPath '/predictedIBD.mat'],'file')
    load('./data/datasets/IBD.mat');  load('./data/datasets/IBDInfo.mat');
    for i = 1:length(IBD)   
        predictedIBD(i,1).protName = IBDInfo(i).protName;
        % predict
        for dbnum = 1:length(dbs)
            testFeatNormal = IBD{dbnum}(IBDInfo(i).dataNum_normal,:);
            testFeatCancer = IBD{dbnum}(IBDInfo(i).dataNum_cancer,:);
            for k = 1:n
                model = classifier((dbnum-1)*n+k);
                [~,testOutputs1{(dbnum-1)*n+k}] = testModel(model,testFeatNormal,2); % criway=2
                [~,testOutputs2{(dbnum-1)*n+k}] = testModel(model,testFeatCancer,2); % criway=2
            end
        end

        % get label sets
        testOut1 = zeros(size(testOutputs1{1}));
        testOut2 = zeros(size(testOutputs2{1}));
        for k = 1:classifierNum
            testOut1 = testOut1 + testOutputs1{k};
            testOut2 = testOut2 + testOutputs2{k};
        end
        testOut1 = testOut1/classifierNum;  testOut2 = testOut2/classifierNum;
        [h,p] = ttest2(testOut2',testOut1');
        predictedIBD(i,1).p_value = [h;p];
        testOut1 = sum(testOut1,2)/size(testOut1,2);
        testOut2 = sum(testOut2,2)/size(testOut2,2);
        preTable1 = getLabelset(testOut1,2,parameters(1),parameters(2)); %criway=2
        preTable2 = getLabelset(testOut2,2,parameters(1),parameters(2)); %criway=2
        predictedIBD(i,1).predictionNormal = find(preTable1 == 1); 
        predictedIBD(i,1).predictionCancer = find(preTable2 == 1);
    end
    save([classifyPath '/predictedIBD.mat'],'predictedIBD');
end   

% 3. test the normal independent data (IDN)
if ~exist([classifyPath '/predictedIDN.mat'],'file')
    load('./data/datasets/data.mat','IDN','IDN_target');
    for dbnum = 1:length(dbs)
        for k = 1:n
            model = classifier((dbnum-1)*n+k);
            [~,indeTestOutputs{(dbnum-1)*n+k}] = testModel(model,IDN{dbnum},2); %criway=2
        end
    end
    % get label sets
    testOut = zeros(size(indeTestOutputs{1}));
    for k = 1:classifierNum
        testOut = testOut + indeTestOutputs{k};
    end
    testOut = testOut/classifierNum;
    preTable = getLabelset(testOut,2,parameters(1),parameters(2)); %criway=2

    % 7. Evaluation
    evalCriteria.subset_accuracy = S_accuracy(preTable,IDN_target);
    [evalCriteria.accuracy,evalCriteria.recall,evalCriteria.precision] = Accuracy(preTable,IDN_target);
    [evalCriteria.label_accuracy, evalCriteria.average_label_accuracy] = L_accuracy(preTable,IDN_target);
    save([classifyPath '/predictedIDN.mat'],'evalCriteria','testOut');
end